#include <stdio.h>
#include <math.h>

#include "BasicDef.h"

// 2{̃xNgvec0vec1̓ρD
double dot(double vec0[], double vec1[])
// double vec0[];
// double vec1[];
{
	return(vec0[X] * vec1[X] + vec0[Y] * vec1[Y] + vec0[Z] * vec1[Z]);
}

// 2{̃xNgvec0vec1̊OρD
void cross(double vec0[], double vec1[], double vec2[])
// double vec0[];
// double vec1[];
// double vec2[]; vec0 X vec1.
{
	vec2[X] = vec0[Y] * vec1[Z] - vec0[Z] * vec1[Y];
	vec2[Y] = vec0[Z] * vec1[X] - vec0[X] * vec1[Z];
	vec2[Z] = vec0[X] * vec1[Y] - vec0[Y] * vec1[X];
}

// xNg̐KD
void normVec(double vec[])
// double vec[]; ӁĨxNg͔jIɕύXD
{
	double norm;
	norm = sqrt(vec[X] * vec[X] + vec[Y] * vec[Y] + vec[Z] * vec[Z]);
	vec[X] /= norm;
	vec[Y] /= norm;
	vec[Z] /= norm;
}

// 3_܂ޕʂ̒Pʖ@xNǧvZD3_vɕł邱
// ƂD
void normal(double p0[], double p1[], double p2[], double normal[])
// double p0[], p1[], p2[]; 3_̍WD
// double normal[]; vZꂽ@xNgD
{
	unsigned int i;
	double v0[3], v1[3];

	// {ƂȂQ̃xNg𐶐D
	for (i = 0; i < 3; i++) {
		v0[i] = p2[i] - p1[i];
		v1[i] = p0[i] - p1[i];
	}

	// xNg̊OςvZD
	cross(v0, v1, normal);

	// Oςɂēꂽ@xNg𐳋KD
	normVec(normal);
}

// @ƒʉߓ_̎w肩畽ʂ̕D
void defPlane(double normal[], double point[], double plane_eq[])
// double normal[]; ʂ̖@xNgD
// double point[]; ʏ1_̍WD
// double plane_eq[]; ʂ̕ax + by + cz + d = 0̌W[a, b, c, d]D
{
	plane_eq[A] = normal[X];
	plane_eq[B] = normal[Y];
	plane_eq[C] = normal[Z];
	plane_eq[D] = - (normal[X] * point[X] + normal[Y] * point[Y] + normal[Z] * point[Z]);
}

// ƕʂ̌_D
void intPointLinePlane(double dir[], double point[], double plane_eq[], double int_point[])
// double dir[]; ̐KꂽxNgD
// double point[]; 1_̍WD
// double plane_eq[]; ʂ̕Dƕsł͂ȂƂD
// double int_point[]; _̍WD
{
	double d, t;
	d = dot(dir, plane_eq);
	t = (- (plane_eq[A] * point[X] + plane_eq[B] * point[Y] + plane_eq[C] * point[Z] + plane_eq[D])) / d;
	int_point[X] = dir[X] * t + point[X];
	int_point[Y] = dir[Y] * t + point[Y];
	int_point[Z] = dir[Z] * t + point[Z];
}
