#include "stdafx.h"
#include <gl/freeglut.h>

#define X 0
#define Y 1
#define Z 2

unsigned int num_points = 5;
double point[][3] = {{0.5, 0.5, 0.0}, {-0.5, 0.5, 0.0}, {-0.5, -0.5, 0.0}, {0.5, -0.5, 0.0}, {0.0, 0.0, 0.0}};

void display(void)
{
	unsigned int i;
	glClear(GL_COLOR_BUFFER_BIT);
	//glBegin(GL_POINTS);
	glBegin(GL_LINE_LOOP);
	for (i = 0; i < num_points; i++)
		glVertex3d(point[i][X], point[i][Y], point[i][Z]);
	glEnd();
	glFlush();
}

void initGL(void)
{
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA);
	glutCreateWindow(argv[0]);
	glutDisplayFunc(display);
	initGL();
	glutMainLoop();
	return 0;
}
